// -------------------------------------------------------------------- create a svg line
String line(float x1, float y1,float x2,float y2,int r,int g,int b){
    String ls = "<line x1="+String(x1);
    ls += "% y1="+String(y1);
    ls += "% x2="+String(x2);
    ls += "% y2="+String(y2);
    ls += "% style=\"stroke:rgb("+String(r);
    ls += ","+String(g);
    ls += ","+String(b);
    ls += ");stroke-width:2\" />";
    return (ls);
  }
  
// -------------------------------------------------------------------- create website
void createHtml(){
    tone(SPEAKER, 1500, 100);
    ws = "<html>\
            <head>\
              <title>YUKIKAKI RESEARCH STATION</title>\
              <meta http-equiv=\"refresh\" content=\"60\">\
              <style>\
              body, html{margin:0px;padding:0px;background:black;}\
              </style>\
            </head>\
            <body>\
              <svg id=\"headline\" viewBox=\"0 0 600 50\"  xmlns=\"http://www.w3.org/2000/svg\">\
                <text text-anchor=\"middle\" font-family=\"monospace\" font-weight=\"bold\" font-size=\"30\" y=\"49\" x=\"300\" fill=\"#ffffff\">YUKIKAKI RESEARCH STATION</text>\
              </svg>\
              <svg id=\"legend\" viewBox=\"0 0 600 400\"  xmlns=\"http://www.w3.org/2000/svg\">\
                <rect fill=\"#000000\" height=\"100%\" width=\"100%\" y=\"-1\" x=\"-1\"/>\
                <line y2=\"260\" x2=\"313.4\" y1=\"356\" x1=\"203\" stroke-width=\"2\" stroke=\"#ffffff\"/>\
                <line y2=\"260\" x2=\"311.4\" y1=\"260\" x1=\"93\" stroke-width=\"2\" stroke=\"#ffffff\"/>\
                <line transform=\"rotate(-60 118.65,213.25) \" y2=\"213.25\" x2=\"284.23\" y1=\"213.25\" x1=\"-46.92\" stroke-width=\"2\" stroke=\"#ffffff\"/>\
                <line transform=\"rotate(60 283.71,213.25) \" y2=\"213.25\" x2=\"449.29\" y1=\"213.25\" x1=\"118.13\" stroke-width=\"2\" stroke=\"#ffffff\"/>\
                <line y2=\"356.31\" x2=\"366.76\" y1=\"356.31\" x1=\"35.61\" stroke-width=\"2\" stroke=\"#ffffff\"/>\
                <line y2=\"117.25\" x2=\"123.41\" y1=\"117.25\" x1=\"174.5\" stroke-width=\"2\" stroke=\"#ffffff\"/>\
                <line y2=\"117.73\" x2=\"123.97\" y1=\"74.72\" x1=\"123.97\" stroke-width=\"2\" stroke=\"#ffffff\"/>\
                <line stroke=\"#ff4400\" y2=\"74.19\" x2=\"143.48\" y1=\"74.19\" x1=\"103.47\" stroke-width=\"2\"/>\
                <ellipse stroke=\"#ff4400\" ry=\"17\" rx=\"17\" cy=\"74.19\" cx=\"94.22\" stroke-width=\"2\"/>\
                <ellipse ry=\"17\" rx=\"17\" cy=\"74.19\" cx=\"154.22\" stroke-width=\"2\" stroke=\"#ff4400\" />\
                <rect height=\"65\" width=\"85\" y=\"168.5\" x=\"67.20\" stroke-width=\"2\" stroke=\"#ffff00\" fill=\"#000000\"/>\
                <rect height=\"65\" width=\"85\" y=\"168.5\" x=\"249.8\" stroke-width=\"2\" stroke=\"#ffff00\" fill=\"#000000\"/>\
                <line y2=\"175.34\" x2=\"317.50\" y1=\"175.34\" x1=\"83.5\" stroke-width=\"2\" stroke=\"#ffff00\"/>\
                <line y2=\"227.23\" x2=\"317.50\" y1=\"227.23\" x1=\"83.5\" stroke-width=\"2\" stroke=\"#ffff00\"/>\
                <line y2=\"259.68\" x2=\"201\" y1=\"156.37\" x1=\"201\" stroke-width=\"2\" stroke=\"#ffffff\"/>\
                <rect height=\"92.09\" width=\"40.68\" y=\"249.48\" x=\"295.35\" stroke-width=\"2\" stroke=\"#0077ff\" fill=\"#000000\"/>\
                <rect height=\"92.09\" width=\"40.68\" y=\"249.48\" x=\"238.85\" stroke-width=\"2\" stroke=\"#0077ff\" fill=\"#000000\"/>\
                <line y2=\"350.61\" x2=\"287.44\" y1=\"242.7\" x1=\"287.44\" stroke-width=\"2\" stroke=\"#0077ff\"/>\
                <line y2=\"155.69\" x2=\"250.72\" y1=\"155.7\" x1=\"152.98\" stroke-width=\"2\" stroke=\"#ffffff\"/>\
                <line y2=\"260.21\" x2=\"91.96\" y1=\"355.7\" x1=\"202.69\" stroke-width=\"2\" stroke=\"#ffffff\"/>\
                <path stroke=\"#ff4400\" fill=\"#ff4400\" stroke-width=\"2\" d=\"m404.65,93.76l-23.94,-17.67l23.94,-17.67l0,8.83l24.06,0l0,17.67l-24.06,0l0,8.83z\"/>\
                <path stroke=\"#ffff00\" fill=\"#ffff00\" stroke-width=\"2\" d=\"m404.65,213.76l-23.94,-17.67l23.94,-17.67l0,8.83l24.06,0l0,17.67l-24.06,0l0,8.83z\"/>\
                <path stroke=\"#0077ff\" fill=\"#0077ff\" stroke-width=\"2\" d=\"m404.65,333.76l-23.94,-17.67l23.94,-17.67l0,8.83l24.06,0l0,17.67l-24.06,0l0,8.83z\"/>\
                <text text-anchor=\"start\" font-family=\"monospace\" font-size=\"26\" y=\"85.05\" x=\"450\" fill=\"#ff4400\">RPM: ";
         ws += String(rpm1);
         ws += "</text>\
                <text text-anchor=\"start\" font-family=\"monospace\" font-size=\"26\" y=\"205.05\" x=\"450\" fill=\"#ffff00\">RPM: ";
         ws += String(rpm2);
         ws += "</text>\
                <text text-anchor=\"start\" font-family=\"monospace\" font-size=\"26\" y=\"325.05\" x=\"450\" fill=\"#0077ff\">RPM: ";
         ws += String(rpm3);
         ws += "</text>\
              </svg>\
              <svg id=\"timeline-title\" viewBox=\"0 0 600 50\"  xmlns=\"http://www.w3.org/2000/svg\">\
              </svg>\
              <svg id=\"graph\" viewBox=\"0 0 780 440\"  xmlns=\"http://www.w3.org/2000/svg\">\
                <rect height=\"400\" width=\"720\" y=\"10\" x=\"30\" stroke-width=\"2.4\" stroke=\"#ffffff\" fill=\"#000000\"/>";
                
         // vertical grey hour lines  
         for (int i=90;i<720;i+=60){ 
             ws += "<line  x1=\""+String(i);
             ws += "\" y1=\"12\" x2=\""+String(i);
             ws += "\" y2=\"408\" stroke-width=\"2.4\" stroke=\"#666666\"/>\
             ";
          }  
          
          // legend:hours  
          for (int h=12;h>0;h-=2){
             ws += "<text text-anchor=\"middle\" font-family=\"monospace\" font-size=\"22\" y=\"440\" x=\"";
             ws += String(map(h,12,0,30,750));
             ws += "\" fill=\"#ffffff\">-";
             ws += String(h);
             ws += "h</text>\
             ";
          }
          ws += "<text text-anchor=\"middle\" font-family=\"monospace\" font-size=\"22\" y=\"440\" x=\"750\" fill=\"#ffffff\">NOW</text>\
             ";

         // graph 1 
         ws += "<polyline points=\"";
         for (int x=3;x<720;x+=3){ 
             ws += String(x+30);
             ws += ",";
             int y=0;
             for (int i=0;i<3;i++){
              y += rpmLog1[x+i];
             }
             y = int(map(y/3,0,maxRpm,408,12));
             ws += String(y);
             ws += " ";
         }
         ws += "748,";
         ws += String(int(map(rpmLog1[719],0,maxRpm,410,10)));
         ws += " \" fill=\"none\" stroke-width=\"2.4\" stroke=\"#ff4400\" />\
         ";

         // graph 2 
         ws += "<polyline points=\"";
         for (int x=3;x<720;x+=3){ 
             ws += String(x+30);
             ws += ",";
             int y=0;
             for (int i=0;i<3;i++){
              y += rpmLog2[x+i];
             }
             y = int(map(y/3,0,maxRpm,408,12));
             ws += String(y);
             ws += " ";
         }
         ws += "748,";
         ws += String(int(map(rpmLog2[719],0,maxRpm,410,10)));
         ws += " \" fill=\"none\" stroke-width=\"2.4\" stroke=\"#ffff00\" />\
         ";

         // graph 3 
         ws += "<polyline points=\"";
         for (int x=3;x<720;x+=3){ 
             ws += String(x+30);
             ws += ",";
             int y=0;
             for (int i=0;i<3;i++){
              y += rpmLog3[x+i];
             }
             y = int(map(y/3,0,maxRpm,408,12));
             ws += String(y);
             ws += " ";
         }
         ws += "748,";
         ws += String(int(map(rpmLog3[719],0,maxRpm,410,10)));
         ws += " \" fill=\"none\" stroke-width=\"2.4\" stroke=\"#0066ff\" />\
         ";
         ws += "</svg>\
            </body>\
          </html>";
  }

// -------------------------------------------------------------------- serve website 
void handleRoot() {
  if (debugMsg) Serial.println("Serve html");
  server.send(200, "text/html", ws);
  tone(SPEAKER, 2000, 100);
}
